

!- ASCIIPICCHIA ENGINE by E-Paper Adventures 2022
!- ----------------------------------------------
!- versione 2.1 (engine)

!- PER UTILIZZARLO IN CBM PRG STUDIO O EQUIVALENTI:
!-  IMPOSTARE ESPANSIONE 35K
!-  IMPOSTARE INDIRIZZO INIZIALE DEL PROGRAMMA A $1C01 (7169) INVECE CHE $1201 (4609)

!-  USO MEMORIA:
!-  DA $0400 (1024)  A $0BFF (4095)  IMMAGINI (3K)
!-  DA $1000 (4096)  A $11FF (4607)  MEMORIA SCHERMO
!-  DA $1200 (4608)  A $13FF (5119)  CODICE IN LINGUAGGIO MACCHINA E ALTRO (0.5K)
!-  DA $1400 (5120)  A $1BFF (7167)  MAPPA CARATTERI (2K)
!-  DA $1C00 (7168)  A $7999 (32767) BASIC (25K) (PROGRAMMA E VARIABILI)
!-  DA $A000 (40960) A $BFFF (49151) IMMAGINI (8K)

!-  IL MOTORE ASCIPICCHIA UTILIZZA CIRCA 2K BASIC 
!-  LE VARIBILI UTILIZZANO (AL MASSIMO) CIRCA 1K 
!-  --->  RIMANGONO CIRCA 22K PER LA PROPRIA AVVENTURA

!- ----------------------------------------------

!- SE SI VOGLIONO USARE VARIABILI TEMPORANEE,
!- USARE SEMPRE DUE LETTERE (XX = 1; AA$ = "...")

!- DE = VARIABILE DI DEBUG
!-  0 = NO DEBUG (GIOCO FINALE)
!-  1 = DEBUG: SALTA INIZIALIZZAZIONE ROUTINE LINGUAGGIO MACCHINA E
!-      PREPARAZIONE FONT. 
!-  2 = DEBUG: COME 1 E SALTA PRESENTAZIONE E NON MOSTRA IMMAGINI

!- PER ATTIVARE SET CARATTERI: POKE 36869,205
!- PER CARATTERI STANDARD:     POKE 36869,192 

!- ----------------------------------------------

!- CICLO DI BASE ASCIIPICCHIA:

!- 1) MOSTRA DESCRIZIONE E OGGETTI NELLA STANZA (+IMMAGINE)
!- 2) CONTATORI E CONDIZIONI STANZA
!- 3) CONDIZIONI GLOBALI
!- 4) ATTESA COMANDO
!- 5) AZIONI STANZA
!- 6) AZIONI GLOBALI
!- 7) AZIONI STANDARD (gestione automatica PRENDI, LASCIA, I, D, G, QUIT, N S E O ; gestione NON PUOI/NON CAPISCO/etc)
!-                    (gestione LOAD/SAVE A B C)
!- ----> poi torna al punto 1 O 2 del ciclo in base a variabile IA e variabile PO

!- DA 2,3,5,6:
!- - SI PUO' TERMINARE IL GIOCO CON PO=-1

!- DA 2,3
!- - SI FORZA UN CAMBIO STANZA CON PO=<numero stanza> (RICORDARSI GOSUB5) --> torna al punto 1 del ciclo

!- DA 5,6:
!- - SI FORZA UN CAMBIO STANZA CON PO=<numero stanza>:IA=2  --> torna al punto 1 del ciclo 
!- - SI GESTISCE UN'AZIONE CON IA=1 --> torna al punto 2 del ciclo

!- ----------------------------------------------


!- ALTRE NOTE:
!- * quando si fanno sparire oggetti che si hanno con se, ricordarsi di
!-   togliere l'ingombro da CW
!- * ricordarsi di controllare la memoria con ?FRE(0) con break durante il gioco
!- * dopo break (durante attesa comando), per tornare al gioco: GOTO61405


!-******************************************************************************
0 DE=0:GOTO100
!- SCRIVI IL TESTO CONTENUTO IN A$ 
1 GOSUB61000:RETURN
!- mantenuto per retro-compatibilita' 
2 GOSUB61000:RETURN
!- FORZA RITORNO A CAPO
4 A$="                     ":GOSUB1:RETURN
!- ATTENDI UN TASTO
5 GOSUB4:A$="PREMI UN TASTO...":GOSUB2
6 GETB$:IFB$<>""THENGOTO6
7 GETB$:IFB$=""THENGOTO7
8 RETURN
!-******************************************************************************


!-------------------------------------------------------------------------------
!- VARIABILI GENERALI 100-109 (attenzione: deve esistere linea 100)
!-------------------------------------------------------------------------------

!- PO = POSIZIONE INIZIALE
!- CC = COLORE COMANDO (COSA FAI?)
!-      1=BIANCO 2=ROSSO 3=AZZURRO 4=VIOLA 5=VERDE 6=BLU 7=GIALLO
!- CT = COLORE TESTO
!-      1=BIANCO 2=ROSSO 3=AZZURRO 4=VIOLA 5=VERDE 6=BLU 7=GIALLO
!- OM = NUMERO MASSIMO DI OGGETTI 
!- OP = NUMERO MASSIMO DI OGGETTI PRENDIBILI 
!- VM = NUMERO MASSIMO DI VARIABILI SITUAZIONE 
!- CW = INGOMBRO ATTUALE
!- IM = INGOMBRO MASSIMO
!- MO = NUMERO MOSSE FATTE

100 PO=1:CC=7:OM=10:OP=4:VM=5:CW=0:IM=100



!-******************************************************************************
110 DIMOP%(OM+1),OW%(OP),OC$(OP),OL$(OM),V%(VM)
111 DIMCO%(8):CO%(1)=5:CO%(2)=29:CO%(3)=159:CO%(4)=156:CO%(5)=30:CO%(6)=31:CO%(7)=158
!-*****************=*************************************************************


!-------------------------------------------------------------------------------
!- VARIABILI SITUAZIONE 120-199
!-------------------------------------------------------------------------------

!- DEFINIRE QUESTE VARIABILI SOLO SE DIVERSE DA 0!
!- ESEMPIO: 121 V%(1)=5

!- 1- PARLATO CON CACTUS 0=NO 1=SI
!- 2- USATA PER ...
!- 3- USATA PER ...
!- 4- USATA PER ...
!- 5- USATA PER ...


!-------------------------------------------------------------------------------
!- VARIABILI OGGETTI 200-299
!-------------------------------------------------------------------------------

!- OP(N)  = POSIZIONE OGGETTO N
!- OW(N)  = PESO OGGETTO N (SOLO PRENDIBILI)
!- OC$(N) = DESCRIZIONE CORTA OGGETTO N (SOLO PRENDIBILI)
!- OL$(N) = DESCRIZIONE LUNGA OGGETTO N

!- OGGETTI PRENDIBILI 
200 OP%(1)=1:OW%(1)=10:OC$(1)="SPAD":OL$(1)="UNA SPADA"

!- OGGETTI NON PRENDIBILI
205 OP%(5)=1:OL$(5)="UN CACTUS"



!-******************************************************************************
300 PRINTCHR$(147);CHR$(30):POKE36879,8:IFDE=0THENPOKE36869,205
301 IFDE=2THENGOTO999
!-******************************************************************************


!-------------------------------------------------------------------------------
!- PRESENTAZIONE 900-998
!-------------------------------------------------------------------------------

!- F = NUMERO IMMAGINE DA MOSTARE NELLA PRESENTAZIONE 
901 F=2:GOSUB60005:GOSUB4:CT=7
!-      1234567890123456789012*234567890123456789012*234567890123456789012
902 A$="      IL DESERTO":GOSUB2:GOSUB4:CT=5
903 A$="E-PAPERADVENTURES '21":GOSUB2:GOSUB4:GOSUB4:CT=3
904 A$="    PREMI UN TASTO":GOSUB2:CT=5:GOSUB6


!-******************************************************************************
999 MO=0:CT=5:FORI=4825TO4889:POKEI,0:NEXT
1000 PRINTCHR$(147):NO=0:SO=0:WE=0:EA=0
!-******************************************************************************


!-------------------------------------------------------------------------------
!- DESCRIZIONE STANZE 1001-1999
!-------------------------------------------------------------------------------

!- ATTENZIONE!
!- LIMITE MASSIMO DI STANZE = 64

!- se temporaneamente non usata, mettere 8
1005 ONPOGOTO1010,1020,8,8,8,8,8,8
1006 ONPO-8GOTO8,8,8,8,8,8,8,8

!- F = NUMERO IMMAGINE DA MOSTARE NELLA STANZA (0=NESSUNA)
!- NO = STANZA SE VADO A NORD
!- SO = STANZA SE VADO A SUD
!- WE = STANZA SE VADO A OVEST
!- EA = STANZA SE VADO A EST

1010 F=1:GOSUB60000:NO=2
!-       1234567890123456789012*234567890123456789012*234567890123456789012
1011 A$="TI TROVI IN UNA LANDA DESOLATA, SOTTO UN SO-LE COCENTE CHE NON TI ":GOSUB1
1012 A$="DA TREGUA.":GOSUB2
1013 GOTO2000

1020 F=3:GOSUB60000:SO=1
!-       1234567890123456789012*234567890123456789012*234567890123456789012
1021 A$="TI TROVI DAVANTI AD   UN'OASI RIGOGLIOSA.":GOSUB2
1022 GOTO2000


!-******************************************************************************
2000 U=PO:GOSUB50300:GOSUB62600
2100 IFIA>0THENGOSUB30000
2101 PB=PO:GOSUB20000:IFPO=-1THENGOTO58000
2102 IFPO<>PBTHENGOTO1000
2103 GOSUB40000:IFPO=-1THENGOTO58000
2104 IFPO<>PBTHENGOTO1000
2200 GOSUB50000:GOSUB2:IA=0:GOSUB61399:IFC$="G"THENPOKEPO+4824,0:GOTO1000
2251 IFC$="D"THENGOTO1000
2252 IFC$="I"THENGOSUB61800:GOTO2100
2253 IFC$="QUIT"THENGOSUB58000:GOTO2100
2300 GOSUB10000:IFIA=0ANDPO>0THENGOSUB5000
2301 IFPO=-1THENGOTO58000
2302 IFIA=1THENGOTO2100
2303 IFIA=2THENGOTO1000
2410 IFC$="N"ANDNO>0THENPO=NO:IA=1:GOTO1000
2411 IFC$="S"ANDSO>0THENPO=SO:IA=1:GOTO1000
2412 IFC$="E"ANDEA>0THENPO=EA:IA=1:GOTO1000
2413 IFC$="O"ANDWE>0THENPO=WE:IA=1:GOTO1000
2500 IFV$="PREN"THENGOSUB60200:IFIA=1THENGOTO2100
2501 IFV$="LASC"THENGOSUB60300:IFIA=1THENGOTO2100
2502 IFV$="LOAD"AND(N$="A---"ORN$="B---"ORN$="C---")THENGOSUB3010:GOSUB5:GOTO1000
2503 IFV$="SAVE"AND(N$="A---"ORN$="B---"ORN$="C---")THENGOSUB3000:GOSUB5:GOTO1000
2900 ONVC+1GOSUB50100,50200,50600,50700,51200,51000,50900,51600:IFVC>0THENIA=1
2999 GOSUB2:GOTO2100
3000 A$=LEFT$(N$,1):OPEN15,8,15:OPEN3,8,3,"@0:SAVE"+A$+",S,W":PRINT#3,A$:GOSUB3030
3001 CLOSE3:IFEN>0THENGOSUB51900:GOSUB2:RETURN
3002 OPEN3,8,3,"@0:SAVE"+A$+",S,W":PRINT#3,STR$(PO):PRINT#3,STR$(MO):PRINT#3,STR$(CW)
3004 FORI=1TOOM:PRINT#3,STR$(OP%(I)):NEXT:FORI=1TOVM:PRINT#3,STR$(V%(I)):NEXT
3005 FORI=1TO64:A%=PEEK(I+4824):PRINT#3,STR$(A%):NEXT:CLOSE3:GOSUB51700:GOSUB2:RETURN
3010 A$=LEFT$(N$,1):OPEN15,8,15:OPEN4,8,4,"SAVE"+A$+",S,R":INPUT#4,C$:GOSUB3030
3011 CLOSE4:IFEN>0THENGOSUB51900:GOSUB2:RETURN
3013 OPEN4,8,4,"SAVE"+A$+",S,R":INPUT#4,A$:PO=VAL(A$)
3014 INPUT#4,A$:MO=VAL(A$):INPUT#4,A$:CW=VAL(A$)
3016 FORI=1TOOM:INPUT#4,A$:OP%(I)=VAL(A$):NEXT:FORI=1TOVM:INPUT#4,A$:V%(I)=VAL(A$):NEXT
3017 FORI=1TO64:INPUT#4,A$:POKEI+4824,VAL(A$):NEXT:CLOSE4:GOSUB51800:GOSUB2:RETURN
3030 EN=99:INPUT#15,EN:CLOSE15:OPEN15,8,15:CLOSE15:RETURN
!-******************************************************************************


!-------------------------------------------------------------------------------
!- AZIONI GLOBALI 5000-9998 (attenzione: deve esistere linea 5000)
!-------------------------------------------------------------------------------

!- C$ = INPUT ESATTO ( "USA SPADA" )
!- V$ = PRIME 4 LETTERE DEL VERBO, AL CASO CON "-" ( "USA" --> "USA-" )
!- N$ = PRIME 4 LETTERE DEL SOSTANTIVO, AL CASO CON "-" ( "SPADA" --> "SPAD" )
!- B$ = V$+N$ ( "USA-SPAD" "SALI----" "DAI-ORO-" )

!- PO = -1 --> FINE DEL GIOCO
!- IA = 1  --> AZIONE PRESA IN CARICO, RITORNA ALL'INPUT
!- IA = 2  --> AZIONE PRESA IN CARICO, MOSTRA DESCRIZIONE STANZA

!- aiuto
5000 IFV$="AIUT"THENGOSUB15000:RETURN


!-******************************************************************************
9999 RETURN
!-******************************************************************************


!-------------------------------------------------------------------------------
!- AZIONI NELLE STANZE 10000-14999 (attenzione: deve esistere linea 10000)
!-------------------------------------------------------------------------------

!- saltare a 8 se non ci sono azioni in quella stanza
10000 ONPOGOTO10100,10200,8,8,8,8,8,8
10004 ONPO-8GOTO8,8,8,8,8,8,8,8

!---------------------------------------
!- LANDA DESOLATA
!---------------------------------------

!- esamina cactus
10100 IFB$="ESAMCACT"THENIA=1:A$="SPINOSO.":GOSUB2:RETURN

!- parla cactus
10101 IFB$="PARLCACT"THENGOSUB15010

10199 RETURN

!---------------------------------------
!- OASI
!---------------------------------------

!- bevi
10200 IFV$="BEVI"THENGOSUB15200:RETURN

10299 RETURN


!-------------------------------------------------------------------------------
!- ESECUZIONE AZIONI O CONDIZIONI 15000-19999
!-------------------------------------------------------------------------------


!-    A$="1234567890123456789012*234567890123456789012*234567890123456789012"
15000 A$="NESSUNO PUO' AIUTARTI.":GOSUB1
15001 IA=1:RETURN

!-    A$="1234567890123456789012*234567890123456789012*234567890123456789012"
15010 A$="<<...SPRECHEN SIE     DEUTSCH?>>":GOSUB2
15011 IA=1:V%(1)=1:RETURN

15100 GOSUB4
15101 A$="CROLLI ESAUSTO DALLA  FATICA...":GOSUB2
15102 GOSUB5:PO=-1:RETURN

15200 GOSUB4
!-    A$="1234567890123456789012*234567890123456789012*234567890123456789012"
15201 A$="EVVIVA, SEI SALVO!    SEI STATO DAVVERO BRA-VO A TERMINARE QUESTA ":GOSUB1
15202 A$="DIFFICILE AVVENTURA.  COMPLIMENTI!!!":GOSUB2
15203 GOSUB5:PO=-1:RETURN


!-------------------------------------------------------------------------------
!- CONDIZIONI NELLE STANZE 20000-29999 (attenzione: deve esistere linea 20000)
!-------------------------------------------------------------------------------

!- saltare a 8 se non ci sono azioni in quella stanza
20000 ONPOGOTO20100,8,8,8,8,8,8,8
20001 ONPO-8GOTO8,8,8,8,8,8,8,8

!-    A$="1234567890123456789012*234567890123456789012*234567890123456789012"

!- LANDA DESOLATA
!- se abbiamo parlato col cactus, prima di ogni comando compare questa frase
20100 IFV%(1)=1THENA$="...ORMAI DELIRI...":GOSUB2:RETURN
20199 RETURN

!- OASI
20200 :
20299 RETURN


!-------------------------------------------------------------------------------
!- CONTATORI 30000-39999 (attenzione: deve esistere linea 30000)
!-------------------------------------------------------------------------------

30000 MO=MO+1

39999 RETURN


!-------------------------------------------------------------------------------
!- CONDIZIONI GLOBALI 40000-49999 (attenzione: deve esistere linea 40000)
!-------------------------------------------------------------------------------

!-    A$="1234567890123456789012*234567890123456789012*234567890123456789012"

!- dopo 10 mosse si muore di fatica
40000 IFMO>10THENGOSUB15100:RETURN

!- dopo 5 mosse avviso, compare prima di ogni comando
40010 IFMO>5THENA$="...SEI ALLA FRUTTA...":GOSUB2:RETURN

49999 RETURN


!-------------------------------------------------------------------------------
!- MESSAGGI BASE
!-------------------------------------------------------------------------------

!-    A$="1234567890123456789012*234567890123456789012*234567890123456789012"
50000 A$="COSA FAI?":RETURN
50100 A$="NON CAPISCO.":RETURN
50200 A$="NON PUOI.":RETURN
50300 G$="QUI VEDI ANCHE:":RETURN
50400 G$="HAI CON TE:":RETURN
50500 A$="NON HAI NULLA CON TE.":RETURN
50600 A$="NON PUOI ANDARCI...":RETURN
50700 A$="NESSUNO TI ASCOLTA...":RETURN
50900 A$="OK.":RETURN
51000 A$="NON LO HAI CON TE...":RETURN
51100 A$="LO HAI GIA' CON TE!":RETURN
51200 A$="NON NE VEDO QUI...":RETURN
51300 A$="HAI GIA' TROPPE COSE  CON TE!":RETURN
51600 A$="NON TROVI NULLA...":RETURN
51700 A$="SITUAZIONE SALVATA!":RETURN
51800 A$="SITUAZIONE CARICATA!":RETURN
51900 A$="SITUAZIONE NON USATA OERRORE DISCO.":RETURN


!-******************************************************************************
!-           A$="1234567890123456789012*234567890123456789012*234567890123456789012"
58000 GOSUB4:A$="FINE DELL'AVVENTURA!  HAI COMPIUTO:"+STR$(MO):GOSUB2:A$="MOSSE.":GOSUB2
58004 A$="VUOI RIPROVARE? (S/N)":GOSUB2:GOSUB61399:IFA$="S"THENPRINTCHR$(147):RUN
58020 A$="A PRESTO!":GOSUB1:FORI=0TO2000:NEXT:POKE760,0:SYS760
!-******************************************************************************


!-------------------------------------------------------------------------------
!- RICERCA VERBO 59000-59999 (attenzione: deve esistere linea 50000)
!-------------------------------------------------------------------------------

!- VC = INDICA GESTIONE DEL COMANDO DA PARTE DELL'ENGINE
!-      SE>0 IL VERBO E' CONOSCIUTO
!-  1 = AL CASO, NON PUOI
!-  2 = AL CASO, NON PUOI ANDARE
!-  3 = AL CASO, NON PUOI PARLARE
!-  4 = AL CASO, NON PUOI PRENDERE
!-  5 = AL CASO, NON PUOI LASCIARE
!-  7 = AL CASO, NIENTE DI INTERESSANTE

59000 VC=0:IFV$="PREN"ORV$="RACC"ORV$="PORT"THENV$="PREN":VC=4:RETURN

59011 IFV$="LASC"ORV$="MOLL"THENV$="LASC":VC=5:RETURN

59013 IFV$="TOGL"ORV$="USA-"ORV$="NUOT"ORV$="SCAV"ORV$="SPIN"ORV$="TIRA"THENVC=1:RETURN
59016 IFV$="MANG"ORV$="BEVI"ORV$="APRI"ORV$="CHIU"ORV$="DAI-"ORV$="ATTA"THENVC=1:RETURN
59017 IFV$="DORM"ORV$="RIPO"ORV$="MORD"ORV$="CHIA"ORV$="POSA"ORV$="STAI"THENVC=1:RETURN
59018 IFV$="ARRA"ORV$="DAI-"THENVC=1:RETURN

59020 IFV$="N---"ORV$="S---"ORV$="E---"ORV$="O---"ORV$="VAI-"ORV$="ESCI"THENVC=2:RETURN
59021 IFV$="SCEN"ORV$="SALI"ORV$="ATTR"ORV$="SCAL"ORV$="SALT"ORV$="ENTR"THENVC=2:RETURN

59030 IFV$="PARL"THENVC=3:RETURN

59031 IFV$="ESAM"ORV$="OSSE"ORV$="GUAR"THENV$="ESAM":VC=7:RETURN

59999 RETURN


!-******************************************************************************
60000 IF(F>0AND(PEEK(PO+4824)>0))ORDE>1THENGOTO60003
60002 IFF>0THENGOTO60005
60003 F=0:W=1:RETURN
60005 W=11:POKE766,0:POKEPO+4824,1
60006 POKE80,PEEK(4891+(F-1)*3):POKE81,PEEK(4890+(F-1)*3):POKE36878,PEEK(4892+(F-1)*3)
60007 SYS4775:RETURN
60200 IFN$=""THENRETURN
60202 GOSUB60250:IFA=0THENRETURN
60203 IFOP%(A)<0THENGOSUB51100:GOSUB2:IA=1:RETURN
60204 IFOP%(A)<>POTHENVC=4:RETURN
60205 IFA>OPTHENVC=1:RETURN
60206 IFOW%(A)+CW>IMTHENGOSUB51300:GOSUB2:IA=1:RETURN
60210 OP%(A)=-1:CW=CW+OW%(A):VC=6:RETURN
60250 A=0:I=1
60251 IFOC$(I)=N$THENA=I:RETURN
60252 I=I+1:IFI>OPTHENRETURN
60253 GOTO60251
60300 IFN$=""THENRETURN
60302 GOSUB60250:IFA=0THENRETURN
60303 IFOP%(A)>-1THENRETURN
60305 OP%(A)=PO:CW=CW-OW%(A):VC=6:RETURN
61000 PRINTCHR$(CO%(CT));:IFA$=""THENRETURN
61001 IFW>22THENGOSUB61100
61002 X$=A$:IFLEN(X$)>22THENX$=LEFT$(A$,22)
61003 POKE214,W-1:POKE211,0:SYS58640:PRINTX$;:W=W+1
61004 IFLEN(A$)>LEN(X$)THENA$=RIGHT$(A$,LEN(A$)-22):GOTO61001
61005 RETURN
61100 POKE38393,CT:POKE38392,CT:POKE38391,CT:POKE4601,46:POKE4600,46:POKE4599,46
61111 GOSUB6:IFF>0THENGOTO61120
61112 SYS4630:GOTO61121
61120 SYS4665
61121 SYS4685:W=19:RETURN
61399 GETB$:IFB$<>""THENGOTO61399
61400 IFW>22THENGOSUB61100
61401 P=4096+(W-1)*22:A=TI:B=0:A$="":L=0:POKEP+33792,CC:POKEP,62:P=P+1:Q=P
61402 POKEP+33792,CC:POKEP,B*32
61403 GETB$:IFB$<>""THENGOTO61410
61404 IFTI-A>30THENB=1-B:A=TI
61405 POKEP,B*32:GOTO61402
61410 B=0:IFB$=CHR$(13)THENGOTO61450
61411 IFB$=CHR$(20)THENGOTO61440
61412 IFB$=" "AND(L>0ORQ=P)THENGOTO61402
61413 IFB$=" "THENL=P-Q+1
61417 IFP-Q>19THENGOTO61402
61420 C=ASC(B$):IF(C<64ORC>90)ANDC<>32THENGOTO61402
61421 IFC<>32THENC=C-64
61423 IFC<>32ANDC<1ANDC>26THENGOTO61402
61429 A$=A$+B$:POKEP,C:P=P+1:GOTO61402
61440 IFQ=PTHENGOTO61402
61441 IFRIGHT$(A$,1)=" "THENL=0
61442 POKEP,32:P=P-1:A$=LEFT$(A$,LEN(A$)-1):GOTO61402
61450 POKEP,32:IFQ=PTHENGOTO61402
61451 IFP>QTHENIFRIGHT$(A$,1)=" "THENGOTO61402
61452 C$=A$:N$="":B$="":C=L:IFC=0THENC=LEN(A$)+1
61453 V$=LEFT$(A$,C-1):IFLEN(V$)>4THENV$=LEFT$(V$,4)
61454 IFLEN(V$)=1THENV$=V$+"---"
61455 IFLEN(V$)=2THENV$=V$+"--"
61456 IFLEN(V$)=3THENV$=V$+"-"
61457 GOSUB59000:IFL>0THENN$=RIGHT$(A$,LEN(A$)-L):GOSUB61810:B$=V$+N$
61458 IFL=0THENB$=V$+"----"
61459 POKEP,32:W=W+1:RETURN
61800 GOSUB50400:GOSUB62700:IFR=0THENGOSUB50500:GOSUB2:RETURN
61804 RETURN
61810 IFLEN(N$)>4THENN$=LEFT$(N$,4):RETURN
61820 IFLEN(N$)=1THENN$=N$+"---"
61821 IFLEN(N$)=2THENN$=N$+"--"
61822 IFLEN(N$)=3THENN$=N$+"-"
61823 RETURN
62600 G=1:R=0:OP%(OM+1)=U
62601 G=G+1:IFOP%(G-1)<>UTHEN62601
62602 IFG-1>OMTHENRETURN
62603 GOSUB62710:GOTO62601
62700 G=1:R=0:C=OP%(OP+1):OP%(OP+1)=-1
62701 G=G+1:IFOP%(G-1)<>-1THEN62701
62702 IFG-1>OPTHENOP%(OP+1)=C:RETURN
62703 GOSUB62710:GOTO62701
62710 A$=OL$(G-1):IFR=0THENR=1:A$=G$:GOSUB62712:A$=OL$(G-1)
62712 IFLEN(A$)=22THENGOSUB1:RETURN
62713 GOSUB2:RETURN
!-******************************************************************************
